{{
**************************************************************************
*
*   Serial_Repeater_DEMO.spin
*   FullDuplexSerial Repeater Driver DEMO V1.0
*   October 2014 Marcus Garfunkel
*
**************************************************************************
}}
' See Serial_Repeater.spin for more information

' Demo setup - set up your FDS ports as you normally would, then run the 'go' method
' with the 2 ports you want to link.

CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000


        'FDS Pins
        Pin_DEBUG_Rx = 31
        Pin_DEBUG_Tx = 30

        'WIFI Pins
        Pin_ESP8266_Tx = 8
        Pin_ESP8266_Rx = 9
        Pin_ESP8266_CS = 10

        
        'FDS Constants
        DEBUG   = 0
        WIFI    = 1



VAR

  
OBJ


  FDS      : "fullDuplexSerial4port.spin"
  DIO      : "dataIO4port.spin"

  rep      : "Serial Repeater.spin"

    
PUB Main | returnVal

  waitcnt(cnt + clkfreq*2)

  'Set ESP8266 power enable pin as an output
  OUTA[Pin_ESP8266_CS]~
  DIRA[Pin_ESP8266_CS]~~

  ''Initialize FDS/DIO
  FDS.INIT
  fds.AddPort(DEBUG, Pin_DEBUG_Rx, Pin_DEBUG_Tx, -1, -1, 0, 0, 115200)        
  fds.AddPort(WIFI,  Pin_ESP8266_Rx,  Pin_ESP8266_Tx,  -1, -1, 0, 0, 115200)  
  fds.stop
  returnVal := fds.Start
  fds.tx(debug, 16) ' Clear Screen
  fds.str(DEBUG, String("FDS Terminal running on cog "))
  dio.dec(DEBUG, returnVal)
  fds.tx(DEBUG, ".")
  fds.tx(DEBUG, 13)

  fds.str(DEBUG, String("This program running on cog "))
  dio.dec(DEBUG, cogid+1)
  fds.tx(DEBUG, ".")
  fds.tx(DEBUG, 13)
   
  returnVal := rep.go(DEBUG, WIFI) 
  fds.str(DEBUG, String("Serial Repeater running on cog "))
  dio.dec(DEBUG, returnVal)
  fds.tx(DEBUG, ".")
  fds.tx(DEBUG, 13)

  fds.str(DEBUG, String("Waking up ESP8266..."))
  waitcnt(clkfreq + cnt)
  OUTA[Pin_ESP8266_CS]~~ 

  repeat

    'Now you can communicate transparently with the ESP8266 from Parallax Serial Terminal

        